Index: code/trunk/src/modules/weapons/IceGunFreezer.cc
===================================================================
--- code/trunk/src/modules/weapons/IceGunFreezer.cc	(revision 11052)
+++ code/trunk/src/modules/weapons/IceGunFreezer.cc	(revision 11071)
@@ -63,17 +63,4 @@
     /**
     @brief
-        The controlling happens here. This method defines what the controller has to do each tick.
-    @param dt
-        The duration of the tick.
-    */
-    void IceGunFreezer::tick(float dt)
-    {
-        SUPER(IceGunFreezer, tick, dt);
-
-
-    }
-
-    /**
-    @brief
         Sets the freeze time variable to the passed value.
     */
@@ -101,5 +88,5 @@
 
         // Check if the freezer is attached to a parent and check if the parent is a SpaceShip
-        if (parent != NULL && parent->isA(Class(SpaceShip)))
+        if (parent != nullptr && parent->isA(Class(SpaceShip)))
         {
             freezedSpaceShip_ = orxonox_cast<SpaceShip*>(parent);
@@ -118,5 +105,5 @@
     void IceGunFreezer::stopFreezing()
     {
-        if (freezedSpaceShip_ != NULL && freezeFactor_ != 0.0)
+        if (freezedSpaceShip_ != nullptr && freezeFactor_ != 0.0)
         {
             freezedSpaceShip_->addSpeedFactor(1/freezeFactor_);
Index: code/trunk/src/modules/weapons/IceGunFreezer.h
===================================================================
--- code/trunk/src/modules/weapons/IceGunFreezer.h	(revision 11052)
+++ code/trunk/src/modules/weapons/IceGunFreezer.h	(revision 11071)
@@ -37,5 +37,4 @@
 #include "weapons/WeaponsPrereqs.h"
 
-#include "tools/interfaces/Tickable.h"
 #include "worldentities/StaticEntity.h"
 #include "graphics/Model.h"
@@ -50,10 +49,9 @@
     @ingroup Weapons
     */
-    class _WeaponsExport IceGunFreezer : public StaticEntity, public Tickable
+    class _WeaponsExport IceGunFreezer : public StaticEntity
     {
         public:
             IceGunFreezer(Context* context);
             virtual ~IceGunFreezer();
-            virtual void tick(float dt);
             virtual void startFreezing();
             virtual void stopFreezing();
Index: code/trunk/src/modules/weapons/RocketController.cc
===================================================================
--- code/trunk/src/modules/weapons/RocketController.cc	(revision 11052)
+++ code/trunk/src/modules/weapons/RocketController.cc	(revision 11071)
@@ -38,4 +38,5 @@
 #include "projectiles/SimpleRocket.h"
 #include "weaponmodes/SimpleRocketFire.h"
+#include "core/CoreIncludes.h"
 
 namespace orxonox
Index: code/trunk/src/modules/weapons/RocketController.h
===================================================================
--- code/trunk/src/modules/weapons/RocketController.h	(revision 11052)
+++ code/trunk/src/modules/weapons/RocketController.h	(revision 11071)
@@ -55,5 +55,5 @@
             virtual ~RocketController();
 
-            virtual void tick(float dt);
+            virtual void tick(float dt) override;
             /**
             @brief Get the rocket that is controlled by this controller.
Index: code/trunk/src/modules/weapons/munitions/FusionMunition.cc
===================================================================
--- code/trunk/src/modules/weapons/munitions/FusionMunition.cc	(revision 11052)
+++ code/trunk/src/modules/weapons/munitions/FusionMunition.cc	(revision 11071)
@@ -34,5 +34,4 @@
 #include "FusionMunition.h"
 #include "core/CoreIncludes.h"
-#include "core/XMLPort.h"
 
 namespace orxonox
@@ -57,8 +56,3 @@
         this->reloadTime_ = 0.5f;
     }
-
-    void FusionMunition::XMLPort(Element& xmlelement, XMLPort::Mode mode)
-    {
-        SUPER(FusionMunition, XMLPort, xmlelement, mode);
-    }
 }
Index: code/trunk/src/modules/weapons/munitions/FusionMunition.h
===================================================================
--- code/trunk/src/modules/weapons/munitions/FusionMunition.h	(revision 11052)
+++ code/trunk/src/modules/weapons/munitions/FusionMunition.h	(revision 11071)
@@ -52,6 +52,5 @@
         public:
             FusionMunition(Context* context);
-            virtual ~FusionMunition() {}
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual ~FusionMunition() = default;
     };
 }
Index: code/trunk/src/modules/weapons/munitions/GravityBombMunition.cc
===================================================================
--- code/trunk/src/modules/weapons/munitions/GravityBombMunition.cc	(revision 11052)
+++ code/trunk/src/modules/weapons/munitions/GravityBombMunition.cc	(revision 11071)
@@ -7,5 +7,4 @@
 #include "GravityBombMunition.h"
 #include "core/CoreIncludes.h"
-#include "core/XMLPort.h"
 
 namespace orxonox
@@ -27,9 +26,4 @@
         this->reloadTime_ = 0.0f;
     }
-
-    void GravityBombMunition::XMLPort(Element& xmlelement, XMLPort::Mode mode)
-    {
-        SUPER(GravityBombMunition, XMLPort, xmlelement, mode);
-    }
 }
 
Index: code/trunk/src/modules/weapons/munitions/GravityBombMunition.h
===================================================================
--- code/trunk/src/modules/weapons/munitions/GravityBombMunition.h	(revision 11052)
+++ code/trunk/src/modules/weapons/munitions/GravityBombMunition.h	(revision 11071)
@@ -27,6 +27,5 @@
         public:
             GravityBombMunition(Context* context);
-            virtual ~GravityBombMunition() {}
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual ~GravityBombMunition() = default;
     };
 
Index: code/trunk/src/modules/weapons/munitions/IceMunition.cc
===================================================================
--- code/trunk/src/modules/weapons/munitions/IceMunition.cc	(revision 11052)
+++ code/trunk/src/modules/weapons/munitions/IceMunition.cc	(revision 11071)
@@ -34,5 +34,4 @@
 #include "IceMunition.h"
 #include "core/CoreIncludes.h"
-#include "core/XMLPort.h"
 
 namespace orxonox
@@ -55,8 +54,3 @@
         this->reloadTime_ = 0.5f;
     }
-
-    void IceMunition::XMLPort(Element& xmlelement, XMLPort::Mode mode)
-    {
-        SUPER(IceMunition, XMLPort, xmlelement, mode);
-    }
 }
Index: code/trunk/src/modules/weapons/munitions/IceMunition.h
===================================================================
--- code/trunk/src/modules/weapons/munitions/IceMunition.h	(revision 11052)
+++ code/trunk/src/modules/weapons/munitions/IceMunition.h	(revision 11071)
@@ -52,6 +52,5 @@
         public:
             IceMunition(Context* context);
-            virtual ~IceMunition() {}
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual ~IceMunition() = default;
     };
 }
Index: code/trunk/src/modules/weapons/munitions/LaserMunition.cc
===================================================================
--- code/trunk/src/modules/weapons/munitions/LaserMunition.cc	(revision 11052)
+++ code/trunk/src/modules/weapons/munitions/LaserMunition.cc	(revision 11071)
@@ -34,5 +34,4 @@
 #include "LaserMunition.h"
 #include "core/CoreIncludes.h"
-#include "core/XMLPort.h"
 
 namespace orxonox
@@ -58,8 +57,3 @@
         this->reloadTime_ = 0.5f;
     }
-
-    void LaserMunition::XMLPort(Element& xmlelement, XMLPort::Mode mode)
-    {
-        SUPER(LaserMunition, XMLPort, xmlelement, mode);
-    }
 }
Index: code/trunk/src/modules/weapons/munitions/LaserMunition.h
===================================================================
--- code/trunk/src/modules/weapons/munitions/LaserMunition.h	(revision 11052)
+++ code/trunk/src/modules/weapons/munitions/LaserMunition.h	(revision 11071)
@@ -52,6 +52,5 @@
         public:
             LaserMunition(Context* context);
-            virtual ~LaserMunition() {}
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual ~LaserMunition() = default;
     };
 }
Index: code/trunk/src/modules/weapons/munitions/LightningMunition.cc
===================================================================
--- code/trunk/src/modules/weapons/munitions/LightningMunition.cc	(revision 11052)
+++ code/trunk/src/modules/weapons/munitions/LightningMunition.cc	(revision 11071)
@@ -34,5 +34,4 @@
 #include "LightningMunition.h"
 #include "core/CoreIncludes.h"
-#include "core/XMLPort.h"
 
 namespace orxonox
@@ -55,8 +54,3 @@
         this->reloadTime_ = 0.5f;    
     }
-
-    void LightningMunition::XMLPort(Element& xmlelement, XMLPort::Mode mode)
-    {
-        SUPER(LightningMunition, XMLPort, xmlelement, mode);
-    }
 }
Index: code/trunk/src/modules/weapons/munitions/LightningMunition.h
===================================================================
--- code/trunk/src/modules/weapons/munitions/LightningMunition.h	(revision 11052)
+++ code/trunk/src/modules/weapons/munitions/LightningMunition.h	(revision 11071)
@@ -52,6 +52,5 @@
         public:
             LightningMunition(Context* context);
-            virtual ~LightningMunition() {}
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual ~LightningMunition() = default;
     };
 }
Index: code/trunk/src/modules/weapons/munitions/MineMunition.cc
===================================================================
--- code/trunk/src/modules/weapons/munitions/MineMunition.cc	(revision 11052)
+++ code/trunk/src/modules/weapons/munitions/MineMunition.cc	(revision 11071)
@@ -54,8 +54,3 @@
         this->reloadTime_ = 0.5f;
     }
-
-    void MineMunition::XMLPort(Element& xmlelement, XMLPort::Mode mode)
-    {
-        SUPER(MineMunition, XMLPort, xmlelement, mode);
-    }
 }
Index: code/trunk/src/modules/weapons/munitions/MineMunition.h
===================================================================
--- code/trunk/src/modules/weapons/munitions/MineMunition.h	(revision 11052)
+++ code/trunk/src/modules/weapons/munitions/MineMunition.h	(revision 11071)
@@ -52,6 +52,5 @@
         public:
             MineMunition(Context* context);
-            virtual ~MineMunition() {}
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual ~MineMunition() = default;
     };
 }
Index: code/trunk/src/modules/weapons/munitions/RocketMunition.cc
===================================================================
--- code/trunk/src/modules/weapons/munitions/RocketMunition.cc	(revision 11052)
+++ code/trunk/src/modules/weapons/munitions/RocketMunition.cc	(revision 11071)
@@ -34,5 +34,4 @@
 #include "RocketMunition.h"
 #include "core/CoreIncludes.h"
-#include "core/XMLPort.h"
 
 namespace orxonox
@@ -55,8 +54,3 @@
         this->reloadTime_ = 0.5f;
     }
-
-    void RocketMunition::XMLPort(Element& xmlelement, XMLPort::Mode mode)
-    {
-        SUPER(RocketMunition, XMLPort, xmlelement, mode);
-    }
 }
Index: code/trunk/src/modules/weapons/munitions/RocketMunition.h
===================================================================
--- code/trunk/src/modules/weapons/munitions/RocketMunition.h	(revision 11052)
+++ code/trunk/src/modules/weapons/munitions/RocketMunition.h	(revision 11071)
@@ -52,6 +52,5 @@
         public:
             RocketMunition(Context* context);
-            virtual ~RocketMunition() {}
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual ~RocketMunition() = default;
     };
 }
Index: code/trunk/src/modules/weapons/munitions/SplitMunition.cc
===================================================================
--- code/trunk/src/modules/weapons/munitions/SplitMunition.cc	(revision 11052)
+++ code/trunk/src/modules/weapons/munitions/SplitMunition.cc	(revision 11071)
@@ -34,5 +34,4 @@
 #include "SplitMunition.h"
 #include "core/CoreIncludes.h"
-#include "core/XMLPort.h"
 
 namespace orxonox
@@ -55,8 +54,3 @@
         this->reloadTime_ = 0.5f;
     }
-
-    void SplitMunition::XMLPort(Element& xmlelement, XMLPort::Mode mode)
-    {
-        SUPER(SplitMunition, XMLPort, xmlelement, mode);
-    }
 }
Index: code/trunk/src/modules/weapons/munitions/SplitMunition.h
===================================================================
--- code/trunk/src/modules/weapons/munitions/SplitMunition.h	(revision 11052)
+++ code/trunk/src/modules/weapons/munitions/SplitMunition.h	(revision 11071)
@@ -52,6 +52,5 @@
         public:
             SplitMunition(Context* context);
-            virtual ~SplitMunition() {}
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual ~SplitMunition() = default;
     };
 }
Index: code/trunk/src/modules/weapons/projectiles/BasicProjectile.cc
===================================================================
--- code/trunk/src/modules/weapons/projectiles/BasicProjectile.cc	(revision 11052)
+++ code/trunk/src/modules/weapons/projectiles/BasicProjectile.cc	(revision 11071)
@@ -88,5 +88,5 @@
                                     // The projectile is destroyed by its tick()-function (in the following tick).
 
-            Pawn* victim = orxonox_cast<Pawn*>(otherObject); // If otherObject isn't a Pawn, then victim is NULL
+            Pawn* victim = orxonox_cast<Pawn*>(otherObject); // If otherObject isn't a Pawn, then victim is nullptr
 
             WorldEntity* entity = orxonox_cast<WorldEntity*>(this);
@@ -146,8 +146,8 @@
     bool BasicProjectile::isObjectRelatedToShooter(WorldEntity* otherObject)
     {
-        for (WorldEntity* shooter = this->getShooter(); shooter != NULL; shooter = shooter->getParent())
+        for (WorldEntity* shooter = this->getShooter(); shooter != nullptr; shooter = shooter->getParent())
             if (otherObject == shooter)
                 return true;
-        for (WorldEntity* object = otherObject; object != NULL; object = object->getParent())
+        for (WorldEntity* object = otherObject; object != nullptr; object = object->getParent())
             if (otherObject == this->getShooter())
                 return true;
Index: code/trunk/src/modules/weapons/projectiles/BillboardProjectile.h
===================================================================
--- code/trunk/src/modules/weapons/projectiles/BillboardProjectile.h	(revision 11052)
+++ code/trunk/src/modules/weapons/projectiles/BillboardProjectile.h	(revision 11071)
@@ -61,5 +61,5 @@
             virtual void setMaterial(const std::string& material);
             virtual const std::string& getMaterial();
-            virtual void changedVisibility();
+            virtual void changedVisibility() override;
 
         private:
Index: code/trunk/src/modules/weapons/projectiles/GravityBomb.cc
===================================================================
--- code/trunk/src/modules/weapons/projectiles/GravityBomb.cc	(revision 11052)
+++ code/trunk/src/modules/weapons/projectiles/GravityBomb.cc	(revision 11071)
@@ -28,5 +28,5 @@
                 this->timeToLife_= LIFETIME;
                 this->setCollisionResponse(false);
-                this->setCollisionType(WorldEntity::Dynamic);
+                this->setCollisionType(WorldEntity::CollisionType::Dynamic);
                 this->enableCollisionCallback();
 
Index: code/trunk/src/modules/weapons/projectiles/GravityBomb.h
===================================================================
--- code/trunk/src/modules/weapons/projectiles/GravityBomb.h	(revision 11052)
+++ code/trunk/src/modules/weapons/projectiles/GravityBomb.h	(revision 11071)
@@ -41,7 +41,7 @@
             GravityBomb(Context* context);
             virtual ~GravityBomb();
-            virtual void tick(float dt);
+            virtual void tick(float dt) override;
 
-            virtual bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* cs, btManifoldPoint& contactPoint);
+            virtual bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* cs, btManifoldPoint& contactPoint) override;
             void detonate();
         private:
Index: code/trunk/src/modules/weapons/projectiles/GravityBombField.cc
===================================================================
--- code/trunk/src/modules/weapons/projectiles/GravityBombField.cc	(revision 11052)
+++ code/trunk/src/modules/weapons/projectiles/GravityBombField.cc	(revision 11071)
@@ -41,5 +41,5 @@
         //Make the Field visible on Radar and minimap.
         this->setRadarObjectColour(ColourValue(1.0, 0.0, 0.2,1)); // Red
-        this->setRadarObjectShape(RadarViewable::Dot);
+        this->setRadarObjectShape(RadarViewable::Shape::Dot);
         this->setRadarObjectScale(1.0f);
         
@@ -125,18 +125,18 @@
 
             //Check if any pawn is inside the shockwave and hit it with dammage proportional to the distance between explosion centre and pawn. Make sure, the same pawn is damaged only once.
-            for (ObjectList<Pawn>::iterator it = ObjectList<Pawn>::begin(); it != ObjectList<Pawn>::end(); ++it)
+            for (Pawn* pawn : ObjectList<Pawn>())
             {
-                Vector3 distanceVector = it->getWorldPosition()-this->getWorldPosition();
+                Vector3 distanceVector = pawn->getWorldPosition()-this->getWorldPosition();
                  //orxout(debug_output) << "Found Pawn:" << it->getWorldPosition() << endl;
                 if(distanceVector.length()< forceSphereRadius_)
                 {
                     //orxout(debug_output) << "Force sphere radius is: " << forceSphereRadius_ << " Distance to Pawn is: " << distanceVector.length();
-                    if (std::find(victimsAlreadyDamaged_.begin(),victimsAlreadyDamaged_.end(),*it) == victimsAlreadyDamaged_.end())
+                    if (std::find(victimsAlreadyDamaged_.begin(),victimsAlreadyDamaged_.end(),pawn) == victimsAlreadyDamaged_.end())
                     {
                         //orxout(debug_output) << "Found Pawn to damage: " << it->getWorldPosition() << endl;
                         float damage = FORCE_FIELD_EXPLOSION_DAMMAGE*(1-distanceVector.length()/EXPLOSION_RADIUS);
                         //orxout(debug_output) << "Damage: " << damage << endl;
-                        it->hit(shooter_, it->getWorldPosition(), NULL, damage, 0,0);
-                        victimsAlreadyDamaged_.push_back(*it);
+                        pawn->hit(shooter_, pawn->getWorldPosition(), nullptr, damage, 0,0);
+                        victimsAlreadyDamaged_.push_back(pawn);
                     }
                 }
Index: code/trunk/src/modules/weapons/projectiles/GravityBombField.h
===================================================================
--- code/trunk/src/modules/weapons/projectiles/GravityBombField.h	(revision 11052)
+++ code/trunk/src/modules/weapons/projectiles/GravityBombField.h	(revision 11071)
@@ -39,5 +39,5 @@
     GravityBombField(Context* context);
     virtual ~GravityBombField();
-    virtual void tick(float dt);
+    virtual void tick(float dt) override;
     virtual void destroy();
 
Index: code/trunk/src/modules/weapons/projectiles/IceGunProjectile.cc
===================================================================
--- code/trunk/src/modules/weapons/projectiles/IceGunProjectile.cc	(revision 11052)
+++ code/trunk/src/modules/weapons/projectiles/IceGunProjectile.cc	(revision 11071)
@@ -120,5 +120,5 @@
             Vector3 offset = this->getWorldPosition() - otherObject->getWorldPosition();
             freezer->setPosition(Vector3(0,0,0));
-            freezer->translate(offset, WorldEntity::World);
+            freezer->translate(offset, WorldEntity::TransformSpace::World);
             // Start the freezing effect.
             freezer->startFreezing();
Index: code/trunk/src/modules/weapons/projectiles/IceGunProjectile.h
===================================================================
--- code/trunk/src/modules/weapons/projectiles/IceGunProjectile.h	(revision 11052)
+++ code/trunk/src/modules/weapons/projectiles/IceGunProjectile.h	(revision 11071)
@@ -62,5 +62,5 @@
 
         protected:
-            virtual bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* cs, btManifoldPoint& contactPoint);
+            virtual bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* cs, btManifoldPoint& contactPoint) override;
             static const float particleDestructionDelay_;
         private:
Index: code/trunk/src/modules/weapons/projectiles/LightningGunProjectile.cc
===================================================================
--- code/trunk/src/modules/weapons/projectiles/LightningGunProjectile.cc	(revision 11052)
+++ code/trunk/src/modules/weapons/projectiles/LightningGunProjectile.cc	(revision 11071)
@@ -48,5 +48,5 @@
         this->textureIndex_ = 1;
         this->setMass(2);
-        this->setCollisionType(Dynamic);
+        this->setCollisionType(CollisionType::Dynamic);
         this->maxTextureIndex_ = 8;
         this->textureTimer_.setTimer(0.01f, true, createExecutor(createFunctor(&LightningGunProjectile::changeTexture, this)));
Index: code/trunk/src/modules/weapons/projectiles/LightningGunProjectile.h
===================================================================
--- code/trunk/src/modules/weapons/projectiles/LightningGunProjectile.h	(revision 11052)
+++ code/trunk/src/modules/weapons/projectiles/LightningGunProjectile.h	(revision 11071)
@@ -58,5 +58,5 @@
             virtual ~LightningGunProjectile() {}
 
-            virtual void setMaterial(const std::string& material);
+            virtual void setMaterial(const std::string& material) override;
 
         private:
Index: code/trunk/src/modules/weapons/projectiles/MineProjectile.cc
===================================================================
--- code/trunk/src/modules/weapons/projectiles/MineProjectile.cc	(revision 11052)
+++ code/trunk/src/modules/weapons/projectiles/MineProjectile.cc	(revision 11071)
@@ -112,5 +112,5 @@
         modelRing4_->yaw(Degree(270));
 
-        emitter_ = NULL;
+        emitter_ = nullptr;
 
         if (GameMode::isMaster())
@@ -121,5 +121,5 @@
             this->enableCollisionCallback();
             this->setCollisionResponse(true);
-            this->setCollisionType(Dynamic);
+            this->setCollisionType(CollisionType::Dynamic);
 
             // Create a sphere collision shape and attach it to the projectile.
@@ -217,10 +217,10 @@
             {
                 // Damage all pawns within the damage radius
-                for (ObjectList<Pawn>::iterator it = ObjectList<Pawn>::begin(); it != ObjectList<Pawn>::end(); ++it)
+                for (Pawn* pawn : ObjectList<Pawn>())
                 {
-                    Vector3 distanceVector = it->getWorldPosition()-this->getWorldPosition();
+                    Vector3 distanceVector = pawn->getWorldPosition()-this->getWorldPosition();
                     if(distanceVector.length()< damageRadius_)
                     {
-                        it->hit(this->getShooter(), it->getWorldPosition(), NULL, this->getDamage(), this->getHealthDamage(), this->getShieldDamage());
+                        pawn->hit(this->getShooter(), pawn->getWorldPosition(), nullptr, this->getDamage(), this->getHealthDamage(), this->getShieldDamage());
                     }
                 }
Index: code/trunk/src/modules/weapons/projectiles/MineProjectile.h
===================================================================
--- code/trunk/src/modules/weapons/projectiles/MineProjectile.h	(revision 11052)
+++ code/trunk/src/modules/weapons/projectiles/MineProjectile.h	(revision 11071)
@@ -57,8 +57,8 @@
             virtual ~MineProjectile();
 
-            virtual void XMLEventPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void XMLEventPort(Element& xmlelement, XMLPort::Mode mode) override;
 
-            virtual void setMaxTimeUntilExplosion(float maxTimeUntilExplosion);
-            virtual void setTimeUntilActivation(float timeUntilActivation);
+            void setMaxTimeUntilExplosion(float maxTimeUntilExplosion);
+            void setTimeUntilActivation(float timeUntilActivation);
         protected:
             static const float triggerRadius_;
@@ -84,7 +84,7 @@
             WeakPtr<DistanceTrigger> distanceTrigger_;
 
-            virtual void destructionEffect();
-            virtual void allowExplosion();
-            virtual void explode();
+            void destructionEffect();
+            void allowExplosion();
+            void explode();
     };
 }
Index: code/trunk/src/modules/weapons/projectiles/ParticleProjectile.cc
===================================================================
--- code/trunk/src/modules/weapons/projectiles/ParticleProjectile.cc	(revision 11052)
+++ code/trunk/src/modules/weapons/projectiles/ParticleProjectile.cc	(revision 11071)
@@ -58,5 +58,5 @@
         }
         else
-            this->particles_ = 0;
+            this->particles_ = nullptr;
     }
 
Index: code/trunk/src/modules/weapons/projectiles/ParticleProjectile.h
===================================================================
--- code/trunk/src/modules/weapons/projectiles/ParticleProjectile.h	(revision 11052)
+++ code/trunk/src/modules/weapons/projectiles/ParticleProjectile.h	(revision 11071)
@@ -53,5 +53,5 @@
             ParticleProjectile(Context* context);
             virtual ~ParticleProjectile();
-            virtual void changedVisibility();
+            virtual void changedVisibility() override;
 
         private:
Index: code/trunk/src/modules/weapons/projectiles/Projectile.cc
===================================================================
--- code/trunk/src/modules/weapons/projectiles/Projectile.cc	(revision 11052)
+++ code/trunk/src/modules/weapons/projectiles/Projectile.cc	(revision 11071)
@@ -57,5 +57,5 @@
             this->enableCollisionCallback();
             this->setCollisionResponse(false);
-            this->setCollisionType(Dynamic);
+            this->setCollisionType(CollisionType::Dynamic);
 
             // Create a sphere collision shape and attach it to the projectile.
@@ -94,5 +94,5 @@
     void Projectile::setCollisionShapeRadius(float radius)
     {
-        if (collisionShape_ != NULL && radius > 0)
+        if (collisionShape_ != nullptr && radius > 0)
         {
             collisionShape_->setRadius(radius);
Index: code/trunk/src/modules/weapons/projectiles/Projectile.h
===================================================================
--- code/trunk/src/modules/weapons/projectiles/Projectile.h	(revision 11052)
+++ code/trunk/src/modules/weapons/projectiles/Projectile.h	(revision 11071)
@@ -64,6 +64,6 @@
             void setConfigValues();
 
-            virtual void tick(float dt);
-            virtual bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* cs, btManifoldPoint& contactPoint);
+            virtual void tick(float dt) override;
+            virtual bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* cs, btManifoldPoint& contactPoint) override;
 
         protected:
Index: code/trunk/src/modules/weapons/projectiles/Rocket.cc
===================================================================
--- code/trunk/src/modules/weapons/projectiles/Rocket.cc	(revision 11052)
+++ code/trunk/src/modules/weapons/projectiles/Rocket.cc	(revision 11071)
@@ -70,5 +70,5 @@
         if (GameMode::isMaster())
         {
-            this->setCollisionType(WorldEntity::Kinematic);
+            this->setCollisionType(WorldEntity::CollisionType::Kinematic);
             this->setVelocity(0,0,-100);
 
@@ -92,5 +92,5 @@
             this->enableCollisionCallback();
             this->setCollisionResponse(false);
-            this->setCollisionType(Kinematic);
+            this->setCollisionType(CollisionType::Kinematic);
 
             // Add collision shape
@@ -117,6 +117,6 @@
         else
         {
-            this->defSndWpnEngine_ = 0;
-            this->defSndWpnLaunch_ = 0;
+            this->defSndWpnEngine_ = nullptr;
+            this->defSndWpnLaunch_ = nullptr;
         }
 
@@ -128,5 +128,5 @@
 
         this->setRadarObjectColour(ColourValue(1.0, 0.5, 0.0)); // orange
-        this->setRadarObjectShape(RadarViewable::Triangle);
+        this->setRadarObjectShape(RadarViewable::Shape::Triangle);
         this->setRadarObjectScale(0.5f);
     }
Index: code/trunk/src/modules/weapons/projectiles/Rocket.h
===================================================================
--- code/trunk/src/modules/weapons/projectiles/Rocket.h	(revision 11052)
+++ code/trunk/src/modules/weapons/projectiles/Rocket.h	(revision 11071)
@@ -62,17 +62,17 @@
             virtual ~Rocket();
 
-            virtual void tick(float dt); //!< Defines which actions the Rocket has to take in each tick.
+            virtual void tick(float dt) override; //!< Defines which actions the Rocket has to take in each tick.
 
-            virtual bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* cs, btManifoldPoint& contactPoint);
-            virtual void destroyObject(void);
+            virtual bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* cs, btManifoldPoint& contactPoint) override;
+            virtual void destroyObject(void) override;
             void destructionEffect();
 
-            virtual void moveFrontBack(const Vector2& value) {}
-            virtual void moveRightLeft(const Vector2& value) {}
-            virtual void moveUpDown(const Vector2& value) {}
+            virtual void moveFrontBack(const Vector2& value) override {}
+            virtual void moveRightLeft(const Vector2& value) override {}
+            virtual void moveUpDown(const Vector2& value) override {}
 
-            virtual void rotateYaw(const Vector2& value);
-            virtual void rotatePitch(const Vector2& value);
-            virtual void rotateRoll(const Vector2& value);
+            virtual void rotateYaw(const Vector2& value) override;
+            virtual void rotatePitch(const Vector2& value) override;
+            virtual void rotateRoll(const Vector2& value) override;
 
             /**
@@ -114,12 +114,12 @@
                 { this->rotateRoll(Vector2(value, 0)); }
 
-            virtual void setShooter(Pawn* shooter);
+            virtual void setShooter(Pawn* shooter) override;
 
-            virtual void fired(unsigned int firemode);
+            virtual void fired(unsigned int firemode) override;
 
             /**
             @brief Set the maximum lifetime of the rocket.
             */
-            virtual void setMaxFuel(float fuel);
+            void setMaxFuel(float fuel);
             /**
             @brief Get the maximum lifetime of the rocket.
@@ -127,5 +127,5 @@
             inline float getMaxFuel() const
                 { return lifetime_; }
-            virtual float getFuel() const;
+            float getFuel() const;
 
         private:
Index: code/trunk/src/modules/weapons/projectiles/RocketOld.cc
===================================================================
--- code/trunk/src/modules/weapons/projectiles/RocketOld.cc	(revision 11052)
+++ code/trunk/src/modules/weapons/projectiles/RocketOld.cc	(revision 11071)
@@ -70,5 +70,5 @@
         if (GameMode::isMaster())
         {
-            this->setCollisionType(WorldEntity::Kinematic);
+            this->setCollisionType(WorldEntity::CollisionType::Kinematic);
             this->setVelocity(0,0,-100);
 
@@ -92,5 +92,5 @@
             this->enableCollisionCallback();
             this->setCollisionResponse(false);
-            this->setCollisionType(Kinematic);
+            this->setCollisionType(CollisionType::Kinematic);
 
             // Add collision shape
@@ -117,6 +117,6 @@
         else
         {
-            this->defSndWpnEngine_ = 0;
-            this->defSndWpnLaunch_ = 0;
+            this->defSndWpnEngine_ = nullptr;
+            this->defSndWpnLaunch_ = nullptr;
         }
 
@@ -128,5 +128,5 @@
 
         this->setRadarObjectColour(ColourValue(1.0, 0.5, 0.0)); // orange
-        this->setRadarObjectShape(RadarViewable::Triangle);
+        this->setRadarObjectShape(RadarViewable::Shape::Triangle);
         this->setRadarObjectScale(0.5f);
     }
Index: code/trunk/src/modules/weapons/projectiles/RocketOld.h
===================================================================
--- code/trunk/src/modules/weapons/projectiles/RocketOld.h	(revision 11052)
+++ code/trunk/src/modules/weapons/projectiles/RocketOld.h	(revision 11071)
@@ -62,17 +62,17 @@
             virtual ~RocketOld();
 
-            virtual void tick(float dt); //!< Defines which actions the RocketOld has to take in each tick.
+            virtual void tick(float dt) override; //!< Defines which actions the RocketOld has to take in each tick.
 
-            virtual bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* cs, btManifoldPoint& contactPoint);
-            virtual void destroyObject(void);
+            virtual bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* cs, btManifoldPoint& contactPoint) override;
+            virtual void destroyObject(void) override;
             void destructionEffect();
 
-            virtual void moveFrontBack(const Vector2& value) {}
-            virtual void moveRightLeft(const Vector2& value) {}
-            virtual void moveUpDown(const Vector2& value) {}
+            virtual void moveFrontBack(const Vector2& value) override {}
+            virtual void moveRightLeft(const Vector2& value) override {}
+            virtual void moveUpDown(const Vector2& value) override {}
 
-            virtual void rotateYaw(const Vector2& value);
-            virtual void rotatePitch(const Vector2& value);
-            virtual void rotateRoll(const Vector2& value);
+            virtual void rotateYaw(const Vector2& value) override;
+            virtual void rotatePitch(const Vector2& value) override;
+            virtual void rotateRoll(const Vector2& value) override;
 
             /**
@@ -114,7 +114,7 @@
                 { this->rotateRoll(Vector2(value, 0)); }
 
-            virtual void setShooter(Pawn* shooter);
+            virtual void setShooter(Pawn* shooter) override;
 
-            virtual void fired(unsigned int firemode);
+            virtual void fired(unsigned int firemode) override;
 
         private:
Index: code/trunk/src/modules/weapons/projectiles/SimpleRocket.cc
===================================================================
--- code/trunk/src/modules/weapons/projectiles/SimpleRocket.cc	(revision 11052)
+++ code/trunk/src/modules/weapons/projectiles/SimpleRocket.cc	(revision 11071)
@@ -70,5 +70,5 @@
         if (GameMode::isMaster())
         {
-            this->setCollisionType(WorldEntity::Kinematic);
+            this->setCollisionType(WorldEntity::CollisionType::Kinematic);
             this->fuel_ = true;
 
@@ -87,5 +87,5 @@
             this->enableCollisionCallback();
             this->setCollisionResponse(false);
-            this->setCollisionType(Kinematic);
+            this->setCollisionType(CollisionType::Kinematic);
 
             // Add collision shape.
@@ -101,5 +101,5 @@
 
         this->setRadarObjectColour(ColourValue(1.0, 1.0, 0.0)); // yellow
-        this->setRadarObjectShape(RadarViewable::Triangle);
+        this->setRadarObjectShape(RadarViewable::Shape::Triangle);
         this->setRadarObjectScale(0.5f);
     }
Index: code/trunk/src/modules/weapons/projectiles/SimpleRocket.h
===================================================================
--- code/trunk/src/modules/weapons/projectiles/SimpleRocket.h	(revision 11052)
+++ code/trunk/src/modules/weapons/projectiles/SimpleRocket.h	(revision 11071)
@@ -62,17 +62,17 @@
             SimpleRocket(Context* context);
             virtual ~SimpleRocket();
-            virtual void tick(float dt);
+            virtual void tick(float dt) override;
 
-            virtual bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* cs, btManifoldPoint& contactPoint);
+            virtual bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* cs, btManifoldPoint& contactPoint) override;
 
             void disableFire(); //!< Method to disable the fire and stop all acceleration
 
-            virtual void moveFrontBack(const Vector2& value){}
-            virtual void moveRightLeft(const Vector2& value){}
-            virtual void moveUpDown(const Vector2& value){}
+            virtual void moveFrontBack(const Vector2& value) override{}
+            virtual void moveRightLeft(const Vector2& value) override{}
+            virtual void moveUpDown(const Vector2& value) override{}
 
-            virtual void rotateYaw(const Vector2& value);
-            virtual void rotatePitch(const Vector2& value);
-            virtual void rotateRoll(const Vector2& value);
+            virtual void rotateYaw(const Vector2& value) override;
+            virtual void rotatePitch(const Vector2& value) override;
+            virtual void rotateRoll(const Vector2& value) override;
             void setDestroy();
 
@@ -115,5 +115,5 @@
                 { this->rotateRoll(Vector2(value, 0)); }
 
-            virtual void setShooter(Pawn* shooter);
+            virtual void setShooter(Pawn* shooter) override;
 
             inline bool hasFuel() const
Index: code/trunk/src/modules/weapons/weaponmodes/EnergyDrink.h
===================================================================
--- code/trunk/src/modules/weapons/weaponmodes/EnergyDrink.h	(revision 11052)
+++ code/trunk/src/modules/weapons/weaponmodes/EnergyDrink.h	(revision 11071)
@@ -57,6 +57,6 @@
             virtual ~EnergyDrink() {}
 
-            virtual void fire();
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void fire() override;
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
 
         private:
Index: code/trunk/src/modules/weapons/weaponmodes/FusionFire.h
===================================================================
--- code/trunk/src/modules/weapons/weaponmodes/FusionFire.h	(revision 11052)
+++ code/trunk/src/modules/weapons/weaponmodes/FusionFire.h	(revision 11071)
@@ -54,5 +54,5 @@
             virtual ~FusionFire() {}
 
-            virtual void fire();
+            virtual void fire() override;
 
         private:
Index: code/trunk/src/modules/weapons/weaponmodes/GravityBombFire.h
===================================================================
--- code/trunk/src/modules/weapons/weaponmodes/GravityBombFire.h	(revision 11052)
+++ code/trunk/src/modules/weapons/weaponmodes/GravityBombFire.h	(revision 11071)
@@ -34,5 +34,5 @@
             virtual ~GravityBombFire();
 
-            virtual void fire();
+            virtual void fire() override;
 
         private:
Index: code/trunk/src/modules/weapons/weaponmodes/HsW01.h
===================================================================
--- code/trunk/src/modules/weapons/weaponmodes/HsW01.h	(revision 11052)
+++ code/trunk/src/modules/weapons/weaponmodes/HsW01.h	(revision 11071)
@@ -56,6 +56,6 @@
             virtual ~HsW01();
 
-            virtual void fire();
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void fire() override;
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
 
         protected:
Index: code/trunk/src/modules/weapons/weaponmodes/IceGun.h
===================================================================
--- code/trunk/src/modules/weapons/weaponmodes/IceGun.h	(revision 11052)
+++ code/trunk/src/modules/weapons/weaponmodes/IceGun.h	(revision 11071)
@@ -54,6 +54,6 @@
             virtual ~IceGun();
 
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            virtual void fire();
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
+            virtual void fire() override;
             
             inline void setFreezeTime(float freezeTime)
Index: code/trunk/src/modules/weapons/weaponmodes/LaserFire.h
===================================================================
--- code/trunk/src/modules/weapons/weaponmodes/LaserFire.h	(revision 11052)
+++ code/trunk/src/modules/weapons/weaponmodes/LaserFire.h	(revision 11071)
@@ -54,5 +54,5 @@
             virtual ~LaserFire() {}
 
-            virtual void fire();
+            virtual void fire() override;
 
         private:
Index: code/trunk/src/modules/weapons/weaponmodes/LightningGun.h
===================================================================
--- code/trunk/src/modules/weapons/weaponmodes/LightningGun.h	(revision 11052)
+++ code/trunk/src/modules/weapons/weaponmodes/LightningGun.h	(revision 11071)
@@ -54,5 +54,5 @@
             virtual ~LightningGun();
 
-            virtual void fire();
+            virtual void fire() override;
 
        private:
Index: code/trunk/src/modules/weapons/weaponmodes/MineGun.h
===================================================================
--- code/trunk/src/modules/weapons/weaponmodes/MineGun.h	(revision 11052)
+++ code/trunk/src/modules/weapons/weaponmodes/MineGun.h	(revision 11071)
@@ -59,6 +59,6 @@
             virtual ~MineGun();
 
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            virtual void fire();
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
+            virtual void fire() override;
 
             inline float getMaxTimeUntilExplosion() const
Index: code/trunk/src/modules/weapons/weaponmodes/RocketFire.h
===================================================================
--- code/trunk/src/modules/weapons/weaponmodes/RocketFire.h	(revision 11052)
+++ code/trunk/src/modules/weapons/weaponmodes/RocketFire.h	(revision 11071)
@@ -54,7 +54,7 @@
             virtual ~RocketFire();
 
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
 
-            virtual void fire();
+            virtual void fire() override;
             inline void setFuel(float fuel)
                 { this->fuel_ = fuel; }
Index: code/trunk/src/modules/weapons/weaponmodes/RocketFireOld.h
===================================================================
--- code/trunk/src/modules/weapons/weaponmodes/RocketFireOld.h	(revision 11052)
+++ code/trunk/src/modules/weapons/weaponmodes/RocketFireOld.h	(revision 11071)
@@ -54,5 +54,5 @@
             virtual ~RocketFireOld();
 
-            virtual void fire();
+            virtual void fire() override;
 
         private:
Index: code/trunk/src/modules/weapons/weaponmodes/SimpleRocketFire.h
===================================================================
--- code/trunk/src/modules/weapons/weaponmodes/SimpleRocketFire.h	(revision 11052)
+++ code/trunk/src/modules/weapons/weaponmodes/SimpleRocketFire.h	(revision 11071)
@@ -53,5 +53,5 @@
             virtual ~SimpleRocketFire();
             void deactivateFire();
-            virtual void fire();
+            virtual void fire() override;
 
         private:
Index: code/trunk/src/modules/weapons/weaponmodes/SplitGun.h
===================================================================
--- code/trunk/src/modules/weapons/weaponmodes/SplitGun.h	(revision 11052)
+++ code/trunk/src/modules/weapons/weaponmodes/SplitGun.h	(revision 11071)
@@ -54,6 +54,6 @@
             virtual ~SplitGun();
 
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            virtual void fire();
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
+            virtual void fire() override;
 
             inline void setNumberOfSplits(int numberOfSplits)
